VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "IWindows"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"IWindow"
Attribute VB_Ext_KEY = "Member0" ,"IWindow"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Enum WindowType
    wtClass = 0
    wtStd = 1
End Enum

Public Enum DisplayAs
    daHide = 0
    daNormalActive = 1
    daMinimized = 2
    daMaximized = 3
    daNormalInactive = 4
    daMinInactive = 7
    daRestore = 9
    daDefault = 10
End Enum

Public Event WindowChange(ByVal hWnd As Long, ByVal strWindowTitle As String, ByVal strClassName As String, ByVal wmMessage As WindowMessage)

Private mcolWindows                     As Collection
Private WithEvents mobjWindowMaster     As IWindowMaster
Attribute mobjWindowMaster.VB_VarHelpID = -1

Public Function Add(ByVal hWnd As Long, ByVal strWindowTitle As String, Optional ByVal strClassName As String, Optional ByVal hWndParent As Long) As IWindow
    On Error Resume Next
    Dim objWindow               As IWindow
    Set objWindow = New IWindow
    With objWindow
        .hWnd = hWnd
        .hWndParent = hWndParent
        .WindowTitle = strWindowTitle
        .ClassName = strClassName
    End With
    mcolWindows.Add objWindow, "_" & hWnd
    If Err.Number Then Set objWindow = Window(hWnd)
    Set Add = objWindow
    Set objWindow = Nothing
End Function

Public Property Get Count() As Long
    Count = mcolWindows.Count
End Property

Public Sub Remove(ByVal hWnd As Long)
    Dim objWindow           As IWindow
    Dim objChild            As IWindow
    Set objWindow = Window(hWnd)
    If objWindow Is Nothing Then Exit Sub
    mcolWindows.Remove "_" & hWnd
    For Each objChild In objWindow
        Remove objChild.hWnd
    Next
    Set objWindow = Nothing
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "440"
    Set NewEnum = mcolWindows.[_NewEnum]
End Property

Public Property Get Window(ByVal hWnd As Long) As IWindow
Attribute Window.VB_UserMemId = 0
    On Error Resume Next
    Set Window = mcolWindows("_" & hWnd)
End Property

Public Sub Display(ByVal hWnd As Long, ByVal daDisplay As DisplayAs)
    ShowWindow hWnd, daDisplay
End Sub

Private Sub mobjWindowMaster_Window(ByVal lngHwnd As Long, ByVal Message As wndcd.WindowMessage)
    On Error Resume Next
    Dim strWindowTitle      As String
    Dim strClassName        As String
    Dim objWindow           As IWindow
    Select Case Message
        Case wmWindowCreated
            GetWindowNames lngHwnd, strWindowTitle, strClassName
            Add lngHwnd, strWindowTitle, strClassName
            EnumChildWindows lngHwnd, AddressOf EnumChildWindowsProc, lngHwnd
        Case wmWindowDestroyed
            strWindowTitle = Window(lngHwnd).WindowTitle
            strClassName = Window(lngHwnd).ClassName
            Remove lngHwnd
    End Select
    RaiseEvent WindowChange(lngHwnd, strWindowTitle, strClassName, Message)
End Sub

Private Sub Class_Initialize()
    On Error Resume Next
    Dim objWindow           As IWindow
    If App.PrevInstance Then Exit Sub
    Set mcolWindows = New Collection
    Set mobjWindowMaster = New IWindowMaster
    Set pobjWindows = Me
    EnumWindows AddressOf EnumWindowsProc, 0&
    For Each objWindow In pobjWindows
        EnumChildWindows objWindow.hWnd, AddressOf EnumChildWindowsProc, objWindow.hWnd
    Next
End Sub

Private Sub Class_Terminate()
    Set mcolWindows = Nothing
    Set mobjWindowMaster = Nothing
End Sub
